# $Id: Server.pm,v 1.15 2004/04/13 20:47:01 joern Exp $

#-----------------------------------------------------------------------
# Copyright (C) 2002-2005 Jrn Reder <joern AT zyn.de>.
# All Rights Reserved. See file COPYRIGHT for details.
# 
# This module is part of Event::RPC, which is free software; you can
# redistribute it and/or modify it under the same terms as Perl itself.
#-----------------------------------------------------------------------

package Event::RPC::Loop::Event;

use strict;
use Event;

sub setup_io_watcher {
	my $class = shift;
	my %par = @_;
	my ($fh, $cb, $desc, $poll) = @par{'fh','cb','desc','poll'};

	return Event->io (
		fd        => $fh,
		poll      => $poll,
		cb        => $cb,
		desc      => $desc,
		reentrant => 0,
	);
}

sub cancel_io_watcher {
	my $class = shift;
	my ($watcher) = @_;
	
	$watcher->cancel;
	
	1;
}

sub enter_loop {
	Event::loop();
}

1;
