# $Id: Server.pm,v 1.15 2004/04/13 20:47:01 joern Exp $

#-----------------------------------------------------------------------
# Copyright (C) 2002-2005 Jrn Reder <joern AT zyn.de>.
# All Rights Reserved. See file COPYRIGHT for details.
# 
# This module is part of Event::RPC, which is free software; you can
# redistribute it and/or modify it under the same terms as Perl itself.
#-----------------------------------------------------------------------

package Event::RPC::Loop::Glib;

use strict;
use Glib;

sub setup_io_watcher {
	my $class = shift;
	my %par = @_;
	my ($fh, $cb, $desc, $poll) = @par{'fh','cb','desc','poll'};

	my $cond = $poll eq 'r' ?
		['G_IO_IN', 'G_IO_HUP']:
		['G_IO_OUT','G_IO_HUP'];
	
	return Glib::IO->add_watch ($fh->fileno, $cond, $cb);
}

sub cancel_io_watcher {
	my $class = shift;
	my ($watcher) = @_;

	Glib::Source->remove ($watcher);
	
	1;
}

sub enter_loop {
	Glib->install_exception_handler(sub {
		print "Event::RPC::Loop::Glib caught an exception: $@\n";
		1;
	});
	Glib::MainLoop->new->run;
}

1;
